local passes = {}


function passes:createCanvases(width, height)
  
  
  
  self.colour  = love.graphics.newCanvas(width, height)
  self.normal  = love.graphics.newCanvas(width, height)
  --self.bloom   = love.graphics.newCanvas(width, height)
  self.overlay = love.graphics.newCanvas(width, height)
  self.final   = love.graphics.newCanvas(width, height)
  
    
  local supportedformats = love.graphics.getCanvasFormats ()

  if supportedformats["r16f"] then
    self.depth = love.graphics.newCanvas(width, height, {format  = "r16f"})
  else
    cout("WARNING - This graphics driver does not support the r16f format, some things may not draw correctly.")
    self.depth = love.graphics.newCanvas(width, height)
  end
end


function passes:clearCanvases()
  love.graphics.setCanvas(self.colour)
  love.graphics.clear(skyColour)
  
  love.graphics.setCanvas(self.normal)
  love.graphics.clear(0.5, 0.5, 1)
  
  love.graphics.setCanvas(self.depth)
  --Gonna set it waaaaaaaaaaaaaaaaaaaaaay back. By that, I mean infinitely back
  love.graphics.clear(-1/0, 0, 0)
  
  love.graphics.setCanvas()
end



function passes:applyLighting()
  

  shader.lambertLighting:send("normalMap", self.normal)
  shader.lambertLighting:send("depthMap", self.depth)
  
  love.graphics.setCanvas(self.final)
  love.graphics.setShader(shader.lambertLighting)
  
  love.graphics.draw(self.colour, 0, 0)
  
  
  love.graphics.setCanvas()
  love.graphics.setShader()
end


function passes:applyBloom()
  
  --Bloom code goes here
  
end



function passes:combineCanvases()
  love.graphics.setColor(1,1,1)
  self:applyLighting()
  --self:applyBloom()
end


function passes:render(x, y)
  x = x or 0
  y = y or 0
  
  self:combineCanvases()

  love.graphics.draw(self.final, x, y)

  self:clearCanvases()
end

return passes
